Feature: For various FAI tasks, most notably when creating an install medium,
a FAI mirror is required.

A FAI mirror is a collection of packages that can be installed. Packages that
are included to a mirror are resolved from package_config/ files in FAI config
space.

  Rule: Mirror creation
    We have a script that can be used to create a FAI mirror.
    That script should work without problems.

    Scenario: Create a Debian 10 FAI mirror
      Given I have distribution "Debian 10"
      When I create a FAI mirror
      Then in the mirror I should have package "dracut-network"

    Scenario: Create a OpenSUSE 15.2 FAI mirror
      Given I have distribution "OpenSUSE 15.2"
      When I create a FAI mirror
      Then in the mirror I should have package "grub2"

    Scenario: Create a Debian 10 mirror when running distribution not compatible with apt-get
      Given I have distribution "Debian 10"
      When I create a FAI mirror using nfsroot
      Then in the mirror I should have package "dracut-network"