Feature: A FAI nfsroot is a minimal chroot installation created from a base
image or directly with debootstrap, to provide a base that can be used to
perform installations or other operations as consistently as possible.

  Scenario: nfsroot creation needs to work for Debian
    Given I have distribution "Debian 10"
    When I generate nfsroot
      | dracut | false |
    Then I should have nfsroot with file "/etc/apt/sources.list"

  Scenario: nfsroot creation needs to work OpenSUSE
    Given I have distribution "OpenSUSE 15.2"
    When I generate nfsroot
      | dracut | false |
    Then I should have nfsroot with file "/etc/zypp/repos.d/opensuse-15.2.repo"

  Scenario: nfsroot is compressed as a base, that can be used to bootstrap a new nfsroot
    Given I have distribution "OpenSUSE 15.2"
    When I generate nfsroot
      | dracut | false |
    Then I save generated base archive

  Scenario: Creating nfsroot from a base archive should work
    Given I have distribution "OpenSUSE 15.2"
    When I generate nfsroot from base archive
      | dracut | false |
    Then I should have nfsroot with file "/etc/zypp/repos.d/opensuse-15.2.repo"