
profiling = false
profiling = true

if profiling
  puts "Removing old profile dir..."
  puts "If you got a permission error, remove the dir manually or disable profiling."
  begin
    FileUtils.rm_r "/tmp/fai-toolkit"
  rescue Errno::ENOENT
    # If dir is missing, all is good.
  end

  require "ruby-prof"

  Dir.mkdir "/tmp/fai-toolkit" unless Dir.exist? "/tmp/fai-toolkit"

  Before do
    @profile = RubyProf::Profile.new
    @profile.exclude_common_methods!
    @profile.exclude_methods!(Cucumber::Core::EventBus, :method_missing, :broadcast)
    @profile.exclude_methods!(Cucumber::Core::Test::Action, :execute, :passed)
    @profile.exclude_methods!(Cucumber::Core::Test::Case, :describe_to)
    @profile.exclude_methods!(Cucumber::Core::Test::Step, :describe_to, :execute, :hook?)
    @profile.exclude_methods!(Cucumber::Core::Test::Result::Passed, :describe_to, :with_appended_backtrace)
    @profile.exclude_methods!(Cucumber::Core::Test::Runner, :test_step)
    @profile.exclude_methods!(Cucumber::Core::Test::Runner::RunningTestCase, :execute)
    @profile.exclude_methods!(Cucumber::Core::Test::Runner::RunningTestCase::Status::Base, :execute)
    @profile.exclude_methods!(Cucumber::CucumberExpressions::ParameterType, :transform)
    @profile.exclude_methods!(Cucumber::Glue::Hook, :invoke)
    @profile.exclude_methods!(Cucumber::Glue::StepDefinition, :invoke)
    @profile.exclude_methods!(Cucumber::StepMatch, :invoke, :deep_clone_args)
    @profile.exclude_methods!(RubyProf::Profile, :_inserted_parent_)
    @profile.start
  end

  After do
    result = @profile.stop

    # print a flat profile to text
    #printer = RubyProf::FlatPrinter.new(result)
    #printer.print(STDOUT)

    printer = RubyProf::MultiPrinter.new(result, [:flat, :graph_html, :tree, :call_info, :stack])
    printer.print(:path => "/tmp/fai-toolkit", :profile => "profile")
  end
end # profiling