
require_relative "fai-toolkit"

# Common option checks that can be used by various different utilities.
module FaiToolkit::Checks
  def check_target_distribution target_distribution
    if target_distribution.nil? and @target_site
      target_distribution = @config&.target&.distribution
    end

    unless target_distribution
      raise "--target-distribution must be given or it needs to be specified at host configurations."
    end

    yield target_distribution

    @target_distribution = target_distribution
  end

  def check_target_distribution_version target_distribution_version, required: false, &block
    if target_distribution_version.nil? and @target_site
      target_distribution_version = @config&.target&.distribution_version
    end

    if required and not target_distribution_version
      raise "--target-distribution-version must be given or it needs to be specified at host configurations."
    end

    yield target_distribution_version if block

    @target_distribution_version = target_distribution_version
  end
end
