
require_relative "nfsroot"

module Nfsroot::FtNfsroot

  private

  def run_nfsroot nfsroot_fai_config_dir, refresh: false, dracut: false
    ARGV << @ft_output_flags if @ft_output_flags
    ARGV << "nfsroot"
    (ARGV << "--no-dracut") if dracut == false
    ARGV << "--fai-config-dir" << nfsroot_fai_config_dir
    ARGV << "--refresh" if refresh
    ARGV.flatten!

    verb "Running “ft nfsroot #{ARGV.join(" ")}”"

    orig_fai = ENV["FAI"]

    ft = FT.new
    ft.options
    ft.perform

    # ft nfsroot may set ENV["FAI"], which is not what we want to have here, as it will be passed with wrong path to ft packages
    ENV["FAI"] = orig_fai
  end
end