
require "fileutils"
require "optimist"

require_relative "../options"
require_relative "online-update"

# Main class.
class OnlineUpdate::Perform
  include Options

  def perform

    sourceslist = "/etc/apt/sources.list"
    FileUtils.mv sourceslist, "#{sourceslist}.BAK"
    FileUtils.cp @sources_list, sourceslist
    at_exit do
      FileUtils.rm sourceslist
      FileUtils.mv "#{sourceslist}.BAK", sourceslist
    end

    execute %{fai -v -N -C /mnt/filesystem/etc/fai -s file:///mnt/filesystem/var/lib/fai/config softupdate}
  end

  def options
    options = Optimist::options do
      opt :sources_list,      "Path to APT’s sources.list containing necessary configuration"
      opt :debug,             "Show debug output"
      opt :verbose,           "Show verbose output"
    end

    unless File.exist? options[:sources_list]
      raise "Given sources.list (#{options[:sources_list]}) does not exist."
    end
    @sources_list = options[:sources_list]

    set_opts options
  end

end

