require "fileutils"

require_relative "packaging"
require_relative "../common"

class Packaging::PackagesImpl
  include Common

  attr_accessor :only_download
  attr_accessor :list_packages
  attr_accessor :download_sources

  attr_accessor :FAI_ROOT

  # @rootcmd as defined in packages.rb
  attr_accessor :rootcmd


  def initialize opts
    @opts = opts
  end

  def startup_checks
    raise "Needs to be implemented in subclass."
  end

  def download_commands pm_command_options, install_options
    raise "Needs to be implemented in subclass."
  end

  def create_package_list packages
    raise "Needs to be implemented in subclass."
  end

  private

  # Write package list to log file.
  def writepackages known
    return if @only_download # do not write the list if we only download packages
    return if @list_packages # do not write the list to a file, just print it

    File.open "#{@FAI_ROOT}/var/log/install_packages.list", "w" do |f|
      f.puts "# List of all packages that will be installed via install_packages"

      known.each do |package|
        f.puts package
      end
    end
  end
end
