
require_relative "packaging"
require_relative "../common"

module Packaging::PackagesMethods
  include Common

  # Shows all available commands.
  def showcommands
    puts "List of known commands for package_config files"
    puts "Short list:"
    @COMMANDS.keys.sort.each do |command|
      next if command.include? "-internal" # skip internal commands
      puts command
    end

    puts "\nLong list:"
    @COMMANDS.keys.sort.each do |command|
      next if command.include? "-internal" # skip internal commands
      printf "%15s    #{@COMMANDS[command]}\n", command;
    end

    exit 0
  end
end