
require_relative "../common"

class Packaging::SSH
  include Common

  def self.ssh ip, command_to_run, user: "root"
    verb "SSH testing: #{command_to_run}"

    # -o PasswordAuthentication=no
    # -o BatchMode=yes
    command = "ssh -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no #{user}@#{ip} #{command_to_run}"
    debug "SSH test command: #{command}"

    read, write, pid = PTY.spawn command

    begin
      result = read.expect /('s p|P)assword: /, 3
      if result.nil?
        puts "Got bad result from command #{command}:"
        puts result
        Process.waitall
        raise "Failed to run command"
      end
      debug "expect result: #{result.inspect}"
    rescue Errno::EIO
      # On Linux, this is thrown if a program has closed the stream.
      # It may or may not be error; if password was expected, it is an error.
      Process.wait pid
      read.close
      write.close
      return ""
    end

    # These sleeps are probably unnecessary, but just to be more safe.
    sleep 0.1

    # Totally insecure password I’ve used in testing.
    write.puts "mau"

    sleep 0.1

    output = ""
    Timeout.timeout(5) do
      buffer = String.new capacity: 1024
      begin
        while not read.eof?
          read.read_nonblock 1024, buffer
          #debug "Buffer: #{buffer}"
          output << buffer
        end
      rescue Errno::EIO
        # On Linux, EIO is thrown when command has finished.
      end
    end

    debug "Got output: #{output.inspect}"

    # Most often should be noop, but sets $? for us.
    Process.wait pid

    output
  end
end